using System;
using System.Collections.Generic;
using jp.netgamers.free.tuogl;	//	bp[
using jp.netgamers.free.tugame;	//	{iIȃt[[N(د


class Sprite : TUSprite
{
	public Sprite( String fname ) : base( fname )
	{
		m_tup.m_tube = TUBufferEx.createRect3Dy( 0, 0, 20,  16, 40 );
		m_tup.m_tube.setTexCoordPointer( new TUBufferEx( new int[]{ 0,1, 1,1, 0,0, 1,0 }, 2 ) );
	}
}

class Player : Sprite
{
//	public Player() : base( "player.png" )
	public Player() : base( "syobon.png" )
	{
	}

	public override void onTimer()
	{
		m_dx = 0;
		m_dy = 0;
		m_dz = 0;
		if( test11.isKeyDown( System.Windows.Forms.Keys.Right ) )	m_dx = 2;
		if( test11.isKeyDown( System.Windows.Forms.Keys.Left  ) )	m_dx = -2;
		if( test11.isKeyDown( System.Windows.Forms.Keys.Up    ) )	m_dy = 2;
		if( test11.isKeyDown( System.Windows.Forms.Keys.Down  ) )	m_dy = -2;
		base.onTimer();
	}
}

class Enemy : Sprite
{
	public Enemy( String fname ) : base( fname )
//	public Enemy() : base()
	{
		m_x = test11.s_rnd.Next( test11.M_WIDTH ) - test11.M_HW;
		m_y = test11.M_HH;
		m_dx = test11.s_rnd.Next( 2 ) + 1;
		m_dy = test11.s_rnd.Next( 2 ) + 1;
	}

	public override void onTimer()
	{
		if( m_x < -test11.M_HW      || m_x > test11.M_HW )	m_dx = -m_dx;
		if( m_y < -test11.M_HH - 44 || m_y > test11.M_HH )	m_dy = -m_dy;
		base.onTimer();
	}
}

/*
class TUMesh
{
	public TUMesh( int x, int y, int z )
	{
		
	}
}
*/

class test11 : TUGame
{
	public static readonly int	M_WIDTH = 256;
	public static readonly int	M_HEIGHT = 144;
	public static readonly int	M_HW = M_WIDTH / 2;
	public static readonly int	M_HH = M_HEIGHT / 2;

	public static Random	s_rnd = new Random();
	int		m_iScore;
	Player	m_player;
	bool	m_bGameOver;
	List<Enemy>	m_enemy = new List<Enemy>();
	static String[]	s_sNinja = { "ninja_blue.png", "ninja_black.png", "ninja_red.png" };


TUTexture	m_texGround;

TUPrimitive	m_ground;
TUPrimitive	m_block_y;
TUPrimitive	m_block_z;

	public override void onCreated()
	{
		setClientSize( M_WIDTH * 2, M_HEIGHT * 2 );	//	ʉ𑜓x
		setOrtho( M_WIDTH, M_HEIGHT );	//	zʉ𑜓x
		GL1.LookAt( 0, -1.732, 1,	0, 0, 0,	0, 0, 1 );
		setTexture2D( true );			//	eNX`L
		setAlphaTest( true );			//	ߊmFL
		GL1.AlphaFunc( GL1._GREATER, 0.5f );	//	臒lݒ
		m_player = new Player();		//	l̎̂𐶐
		setBackground( 0x00000000 );	//	wiFݒ
		setFrameRate( 60 );				//	XVԊuݒ



m_texGround = new TUTexture( test11.readAssetsBitmap( "ground.png" ), true );
m_ground = new TUPrimitive();
m_ground.m_tube = TUBufferEx.createRect3Dz( 0, 0, 0,  16, 16 );
m_ground.m_tube.setTexCoordPointer( new TUBufferEx( new int[]{ 0,1, 1,1, 0,0, 1,0 }, 2 ) );


m_block_y = new TUPrimitive();
m_block_y.m_tube = TUBufferEx.createRect3Dy( 0, 0, 10,  16, 20 );
m_block_z = new TUPrimitive();
m_block_z.m_tube = TUBufferEx.createRect3Dz( 0, 8, 20,  16, 16 );
	}

	public override void onTimer()
	{
		if( m_bGameOver ){
			return;
		}
		m_player.onTimer();
		foreach( Enemy e in m_enemy ){
			e.onTimer();
		}
		Invalidate();
	}

	public override void onDraw()
	{
		base.onDraw();
		setDepthTest( true );


m_texGround.bind();
for( int y = -7; y <= 7; y++ ){
	for( int x = -7; x <= 7; x++ ){
//GL1.Color4( (uint)( 0xffaa5500 + x * 0x5500 + y * 0x55 ) );
m_ground.draw( x * 16, y * 16, 0 );
	}
}
setTexture2D( false );

GL1.Color4( 0xff555555 );m_block_y.draw( 0, 0, 0 );
GL1.Color4( 0xffaaaaaa );m_block_z.draw( 0, 0, 0 );

GL1.Color4( 0xff555555 );m_block_y.draw( 32, 0, 0 );
GL1.Color4( 0xffaaaaaa );m_block_z.draw( 32, 0, 0 );

GL1.Color4( 0xff555555 );m_block_y.draw( 64, 0, 0 );
GL1.Color4( 0xffaaaaaa );m_block_z.draw( 64, 0, 0 );

GL1.Color4( 0xffffffff );
setTexture2D( true );

		m_player.draw();

		if( m_iScore % 50 == 0 ){
			
			m_enemy.Add( new Enemy( s_sNinja[ s_rnd.Next( 3 ) ] ) );
		}
		foreach( Enemy e in m_enemy ){
			e.draw();
			if( e.isCollision( m_player, 12 ) ){
				m_bGameOver = true;
				setDepthTest( false );
				drawText( "GAME OVER", -50, 0 );
				break;
			}
		}

		setDepthTest( false );
		drawText( "SCORE " + m_iScore++, -M_HW, 90 );
	}

	static void Main()
	{
		new test11();
	}
}
